VERSION 5.00
Begin VB.Form FrmVbToExl 
   BackColor       =   &H00D8E9EC&
   BorderStyle     =   4  'Fixed ToolWindow
   Caption         =   "Vb to Excel by Arun Banik"
   ClientHeight    =   1935
   ClientLeft      =   45
   ClientTop       =   285
   ClientWidth     =   3750
   BeginProperty Font 
      Name            =   "Verdana"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   Moveable        =   0   'False
   ScaleHeight     =   1935
   ScaleWidth      =   3750
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Begin VB.Frame Frame1 
      BackColor       =   &H00D8E9EC&
      Caption         =   "Select a code"
      BeginProperty Font 
         Name            =   "Verdana"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1695
      Left            =   120
      TabIndex        =   2
      Top             =   120
      Width           =   3495
      Begin VB.CommandButton CmdHelp 
         Caption         =   "Help"
         BeginProperty Font 
            Name            =   "Verdana"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   375
         Left            =   2160
         TabIndex        =   4
         ToolTipText     =   "Learn more about the project"
         Top             =   720
         Width           =   1095
      End
      Begin VB.CommandButton CmdExit 
         Caption         =   "Exit"
         BeginProperty Font 
            Name            =   "Verdana"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   375
         Left            =   2160
         TabIndex        =   3
         ToolTipText     =   "Exit"
         Top             =   1200
         Width           =   1095
      End
      Begin VB.ListBox LstCode 
         BackColor       =   &H00C0E0FF&
         BeginProperty Font 
            Name            =   "Verdana"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         ForeColor       =   &H000000C0&
         Height          =   1230
         Left            =   120
         TabIndex        =   0
         ToolTipText     =   "Select a code to export"
         Top             =   360
         Width           =   1215
      End
      Begin VB.CommandButton CmdExport 
         Caption         =   "Export"
         BeginProperty Font 
            Name            =   "Verdana"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   375
         Left            =   2160
         TabIndex        =   1
         ToolTipText     =   "Export data"
         Top             =   240
         Width           =   1095
      End
   End
End
Attribute VB_Name = "FrmVbToExl"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'******************************************************************************
'******************************************************************************
'*** VB to Excel                                                            ***
'*** Author    : Arun Banik (Mumbai, India)                                 ***
'*** E-mail    : arun7331@hotmail.com                                       ***
'***                                                                        ***
'*** Purpose   : It is an enhanced version of my previously submitted       ***
'***             code. The purpose of this programme is to generate         ***
'***             report by exporting data into an Ms-Excel sheet from       ***
'***             an Ms-Access database. It will also display the            ***
'***             sub total and grand total of the amount column at          ***
'***             runtime. In this report, I am using the date column        ***
'***             as the group.                                              ***
'***      ###############################################################   ***
'***             To see more codes submitted by me, type the URL            ***
'***             http://www.vbcode.com/default.htm, and enter Arun Banik    ***
'***             in the Search Database box and press enter.                ***
'***      ###############################################################   ***
'*** Note:       Due to lots of feedback from many developers I have made   ***
'***             some changes and included more functions into this project,***
'***             so that the reports can be generated quickly and           ***
'***             efficiently. Thanks very much for all the feedbacks and    ***
'***             sugestions.                                                ***
'*** What's New : 1) The whole sheet is protected by a password, using a    ***
'***             function called Protect. Eg: Worksheet.Protect.            ***
'***             In this demo project, I have used the Protect function to  ***
'***             prevent the sheet from editing, ie., the sheet cannot be   ***
'***             modified till a password is entered. Excel will prompt for ***
'***             a password when the user UnProtects the sheet. To UnProtect***
'***             the sheet goto Tools menu and click Protection submenu and ***
'***             select Unprotect Sheet... Excel will prompt the user to    ***
'***             enter a password. For this project I have set the password ***
'***             as 'Arun'.                                                 ***
'***                                                                        ***
'***              2) To modify a particular cell, we need to set the cells  ***
'***             locked property to false BEFORE setting the the sheet as   ***
'***             protected . For this I have set the                        ***
'***             Cells(10,4).locked = False. Any number of cells, a         ***
'***             particular row or rows can be set as .locked = False. It   ***
'***             will mean that when you PROTECT the whole sheet from editing,
'***             only these UNLOCK cells will be allowed for editing.       ***
'***             Rest will be in read mode.                                 ***
'***
'***              3) The report is generated much faster than the previous  ***
'***             version.                                                   ***
'***                                                                        ***
'***              You got any comments or suggestions please send me a      ***
'***              mail at arun7331@hotmail.com                              ***
'******************************************************************************
'******************************************************************************

Private Sub Form_Load()
    ' Populate the list box with distinct code
    rsGetDistCode.Open "select distinct trcode from TRPC0104", con, adOpenDynamic, adLockOptimistic
    While Not rsGetDistCode.EOF
        LstCode.AddItem rsGetDistCode.Fields(0).Value
        rsGetDistCode.MoveNext
    Wend
End Sub

Private Sub Form_Activate()
    SetCursorPos ((Screen.Width - Me.Width) / 2) / 15 + _
                LstCode.Left / 15 + LstCode.Width / 30, _
                ((Screen.Height - Me.Height) / 2) / 15 + _
                LstCode.Top / 15 + LstCode.Height / 30
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Set con = Nothing
    Set ExlObj = Nothing
    Set rsGetDistCode = Nothing
    Set rsGetAllData = Nothing
    End
End Sub

Private Sub CmdExport_Click()
' Click event of this button will open an Excel sheet, _
  with all the data's from an Access database. Functions like _
  Autoformat and Protect are used to generate more acurate _
  reports and secured reports.
On Error Resume Next
    Dim lc, NxtLine, k
    If Trim(LstCode.Text) <> "" Then
        Screen.MousePointer = vbHourglass
        Connect
        Set ExlObj = CreateObject("excel.application")      ' Initialize the excel object
        ExlObj.Workbooks.Add                                ' Add an excel workbook
        ' Get the required data from the database
        rsGetAllData.Open "select ACCODE,CONTROL,TRNOS,DATE,TRCODE,AMOUNT,STAFFNOS from " & _
                 "TRPC0104 where TRCODE = '" + Trim(LstCode.Text) + "'", con, adOpenDynamic, adLockOptimistic
        If Not rsGetAllData.EOF Then
          ExlObj.Visible = True         ' Show the excel sheet
          With ExlObj.ActiveSheet
            ' Print the heading and columns first
            .Cells(1, 3).Value = "VB TO EXCEL DEMO by Arun Banik"
            .Cells(1, 3).Font.Name = "Verdana"
            .Cells(1, 3).Font.Bold = True:
            .Cells(4, 1).Value = "AC-Code":    .Cells(4, 2).Value = "Control"
            .Cells(4, 3).Value = "TR-Nos":     .Cells(4, 4).Value = "Date"
            .Cells(4, 5).Value = "TR-Code":    .Cells(4, 6).Value = "Amount"
            .Cells(4, 7).Value = "Staff Nos"
          End With
        End If
        For k = 1 To rsGetAllData.Fields.Count
            ' Column headings are set to bold and white.
            ExlObj.ActiveSheet.Cells(4, k).Font.Bold = True
            ExlObj.ActiveSheet.Cells(4, k).Font.Color = vbWhite
        Next
        Set k = Nothing
        NxtLine = 5
        
        ' Now we will export data into the sheet
        Do Until rsGetAllData.EOF
            For lc = 0 To rsGetAllData.Fields.Count - 1
                ExlObj.ActiveSheet.Cells(NxtLine, lc + 1).Value = rsGetAllData.Fields(lc)
                If rsGetAllData.Fields.Item(lc).Name <> "DATE" Then
                   ExlObj.ActiveSheet.Cells(NxtLine, lc + 1).Value = rsGetAllData.Fields(lc)
                Else
                   ExlObj.ActiveSheet.Cells(NxtLine, lc + 1).Value = Format(rsGetAllData.Fields(lc), "dd/mm/yy")
                End If
                
            Next
            rsGetAllData.MoveNext
            NxtLine = NxtLine + 1
        Loop
        
        ' Once the data has been exported, we will format the sheet _
          by using the AutoFormat function.
        ExlObj.ActiveCell.Worksheet.Cells(NxtLine, lc + 1).AutoFormat _
               xlRangeAutoFormatList2, 0, regular, 3, 1, True, True
        'ExlObj.ActiveCell.Worksheet.Cells.AutoFormat  '<- Click the space key after _
                                                         .AutoFormat to see its _
                                                         parameter types.
        ' The parameters of .AutoFormat functions. _
         1) xlRangeAutoFormatList2 - Format style _
         2) 0 - Number format _
         3) regular - Font Style _
         4) 3 - Cell Alignment (Left 1, Right 2 and Center 3). We can change the _
            alignments accordingly. _
         5) 1 - Border _
         6) True - Pattern. Change the pattern to false and see what happens. _
         7) True - Width/Height. Change it to false and see what happens.
            ' With the .AutoFormat function we don't have to worry about setting _
              the width and height of the cells. Every thing is done automaticaly by _
              the function itself. For more, open Excel Sheet and goto Format menu. _
              Click AutoFormat submenu and select the Options button.
        
        ' Now calculate the total using .Subtotal function
        ExlObj.ActiveCell.Worksheet.Cells(4, 1).Subtotal 4, xlSum, (6), 0, 0, xlSummaryBelow
        ' ExlObj.ActiveCell.Worksheet.Cells.Subtotal    ' <- Click the space key after .Subtotal to see _
                                                             parameter lists.
        
        ' I am protecting the whole sheet, except the cell(10,4), which will be unlocked _
          for modification. We can select any number cells or a particular row for _
          modification if the the whole sheet has been protected by a password.
          
        ' So first unlock the cell, which is to be modified if the the sheet is protected.
        ExlObj.ActiveCell.Worksheet.Cells(10, 4).Locked = False
        ' Then protect the whole sheet by using a password.
        ExlObj.ActiveCell.Worksheet.Protect "Arun", False, True, True, False
        
       ' The Protect function mentioned above takes four parameters. _
        1) Password:  Optional Variant.  A string that specifies a _
           case-sensitive password for the worksheet or workbook. If this argument _
           is omitted, you can unprotect the worksheet or workbook without using a _
           password. Otherwise, you must specify the password to unprotect the _
           worksheet or workbook. If you forget the password, you cannot unprotect the _
           worksheet or workbook. _
        2) DrawingObjects:  Optional Variant. True to protect shapes. The default value _
           is False. _
        3) Contents:  Optional Variant. True to protect contents. For a chart, _
           this protects the entire chart. For a worksheet, this protects the _
           locked cells. The default value is True. _
        4) Scenarios:  Optional Variant. True to protect scenarios. This argument _
           is valid only for worksheets. The default value is True. _
        5) UserInterfaceOnly:  Optional Variant. True to protect the user interface, _
           but not macros. If this argument is omitted, protection applies both to _
           macros and to the user interface.
        
        Screen.MousePointer = vbDefault
    Else
        MsgBox "Please select a code" & Chr(13) & "and then proceed", vbInformation
        Screen.MousePointer = vbDefault
        Exit Sub
    End If
End Sub

Private Sub CmdHelp_Click()
    MsgBox "Select a code like BK, BP or Br etc and click the Export button." & vbCrLf & _
           "The excel sheet which will open is a protected sheet ie., " & vbCrLf & _
           "it cannot be modified unless you enter a password. To UnProtect" & vbCrLf & _
           "the sheet goto Excel Tools menu and click Protection Submenu and then" & vbCrLf & _
           "select UnProtect Sheet. Excel will prompt a password. Enter the" & vbCrLf & _
           "password as Arun. (Passwords are case sensitive) Once the correct" & vbCrLf & _
           "password is entered excel will allow editing of the sheet." & vbCrLf & _
           "Excel sheets can be protected from Visual basic. Also particular" & vbCrLf & _
           "cells or rows can be set for editing from Visual basic. In this" & vbCrLf & _
           "demo project I have made the cells(10,4) as editable when the" & vbCrLf & _
           "sheet is protected." & vbCrLf & vbCrLf & _
           "This is a demo project, designed basicaly for programmers," & vbCrLf & _
           "who wants to design reports or export data into Ms-Excel sheets." & vbCrLf & _
           "Multiple sheets can be scaned and uploaded from excel to any database.", vbInformation
End Sub

Private Sub CmdExit_Click()
    Set con = Nothing
    Set ExlObj = Nothing
    Set rsGetDistCode = Nothing
    Set rsGetAllData = Nothing
    End
End Sub

'SELECT Fl.Folio_No, Fl.Inv_Name, Fl.Address1, Fl.Address2, Fl.Address3, Fl.Email,
'Fl.Office_Phone1, Fl.Residence_Phone1, PT.Broker_Code, PT.SubBroker_Code,
'PT.Trxn_Date , Sch.Sch_Name, PT.Amount
'FROM FOLIO Fl, PROCESSED_TRANSACTION PT, SCHEME Sch
'Where
'Fl.Folio_No = PT.Folio_No AND
'Fl.Create_Date = PT.Process_Date AND
'Sch.Sch_Code = PT.Sch_Code AND
'Fl.create_date = '19-Jun-03'
