Attribute VB_Name = "Module1"
Option Explicit
Public con As ADODB.Connection
Public rsGetDistCode As ADODB.Recordset
Public rsGetAllData As ADODB.Recordset
Public sCmd As String                   ' Command string
Public ExlObj As Excel.Application      ' Create excel object

' Api Functions
' For screen resolutions
Private Declare Function GetSystemMetrics Lib "user32" (ByVal Index As Long) As Long
' Cursor function
Public Declare Function SetCursorPos Lib "user32" (ByVal X As Long, ByVal Y As Long) As Long

Sub Connect()
' Purpose: It will create a connection between _
           the database
           
On Error GoTo ConError
    ' I am using an ADO connection
    sCmd = "Provider = Microsoft.Jet.OLEDB.3.51; persist security info = false;"
    sCmd = sCmd & " data source = " & App.Path & "\" & "DemoData.mdb"
    
    ' Set the connections.
    Set con = New ADODB.Connection
    With con
       .ConnectionString = sCmd
       .Open
    End With
    Set rsGetDistCode = New ADODB.Recordset
    Set rsGetAllData = New ADODB.Recordset
    Exit Sub
ConError:
    If Err.Number <> 0 Then
        MsgBox Err.Description & vbCrLf & Err.Source, , "Error in connect"
        End
    End If
End Sub

Public Sub Main()
On Error GoTo Ert
    Dim X As Long, Y As Long             'Screen Resolution Coordinator
    
    X = GetSystemMetrics(0)              ' to check screen resolution for 800 X 600 only
    Y = GetSystemMetrics(1)
    If X < 800 Or Y < 600 Then
        MsgBox "Application Will Work in 800 X 600 or Greater Mode Only", vbCritical + vbOKOnly, "Screen Resolution"
        End
    End If
    
    ' To prevent more than one instance of application on same machine
    If App.PrevInstance = True Then
        MsgBox "One Instance is Already Running !", vbCritical + vbOKOnly, "Error"
        End
    End If
    Connect                     ' Call connect function.
    frmSplash.Show
    FrmVbToExl.Show vbModal     ' If connection made with the database open the main form.
    Exit Sub
Ert:
    If Err.Number <> 0 Then
        MsgBox Err.Description & vbCrLf & Err.Source, , "Error in main"
        End
    End If
End Sub
